<?php


namespace MetatickPluginLib\Http\Client;


class Response
{
    public $url = null;
    public $response = null;
    public $headers = null;
    public $body = null;
    public $code = null;
    public $message = null;
    public $cookies = null;
    public $filename = null;

    public function __construct($url, $response)
    {
        $this->url = $url;
        $this->response = $response;
        $this->headers = $response['headers'];
        $this->body = $response['body'];
        $this->code = $response['response']['code'];
        $this->message = $response['response']['message'];
        $this->cookies = $response['cookies'];
        $this->filename = $response['filename'];
    }

    public function raise_for_status()
    {
        if($this->code >= 400 && $this->code < 500){
            throw new HttpClientException("$this->code Client Error: $this->message for url: $this->url", $this->code, null, $this);
        }

        if($this->code >= 500 && $this->code < 600){
            throw new HttpClientException("$this->code Server Error: $this->message for url: $this->url", $this->code, null, $this);
        }
    }

    public function json(){
        return json_decode($this->body);
    }
}
