<?php

namespace MetatickPluginLib\Model;

use \Exception;

class Model {
    protected $properties = array();

    public function __set($name, $value) {
        $this->properties[$name] = $value;
    }

    public function __get($name) {
        if (array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }

        if (array_key_exists($name, static::$default)) {
            return static::$default[$name];
        }

        throw new Exception('Attempt to access non-existent property: ' . $name);
    }

    public function __isset($name) {
        return isset($this->properties[$name]) || isset(static::$default[$name]);
    }

    public function __unset($name) {
        unset($this->properties[$name]);
    }

    public function save() {
        throw new Exception('save() not implemented');
    }
}