<?php


namespace MetatickPluginLib\View;


use MetatickPluginLib\Http\TemplateResponse;

trait RequireLicenseTrait
{
    protected $license_template = 'license.html';

    public function get_license_template()
    {
        return $this->license_template;
    }

    public function dispatch(){
        $license = static::license();
        if($license->is_licensed()) {
            return parent::dispatch();
        }else{
            $context = ['license' => $license];
            $template = $this->get_license_template();
            $engine = $this->get_template_engine();

            $this->response = new TemplateResponse($template, $context, $engine);
            return $this->response;
        }
    }
}